#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QSettings>
#include <QDir>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    on_actionLoad_triggered ();
}

MainWindow::~MainWindow()
{
    on_actionSave_triggered ();
    delete ui;
}

void MainWindow::on_actionQuit_triggered()
{
    close ();
}

void MainWindow::on_actionSave_triggered()
{
    // #include <QSettings>
    // QSettings s ("MyCompany", "MyAppl");
    QSettings s ("config.ini", QSettings::IniFormat);
    s.beginGroup ("parameters");
    s.setValue ("text", ui->lineEdit->text ());
    s.setValue ("number", ui->spinBox->value ());
    s.endGroup ();
    s.sync ();
}

void MainWindow::on_actionLoad_triggered()
{
    QSettings s ("config.ini", QSettings::IniFormat);
    s.beginGroup ("parameters");

    QString a = s.value ("text", "nic").toString();
    ui->lineEdit->setText (a);

    int n = s.value ("number", 99).toInt();
    ui->spinBox->setValue (n);

    s.endGroup ();
    s.sync ();

}

void MainWindow::showBranch (QTreeWidgetItem * branch,
                             QDir d,
                             int level)
{
    QFileInfoList list = d.entryInfoList
                        (QDir::AllEntries | QDir::NoDotAndDotDot);
    foreach (QFileInfo entry, list)
    {
        QTreeWidgetItem * item = new QTreeWidgetItem;
        item->setText (0, entry.fileName());
        if (entry.isDir ())
            item->setForeground (0, QColor ("red"));
        else
            item->setForeground (0, QColor ("green"));

        if (entry.isDir () && level > 1)
        {
            QDir subdir (entry.absoluteFilePath());
            showBranch (item, subdir, level-1);
        }

        branch->addChild (item);
    }
}
void MainWindow::on_actionRun_triggered()
{
    // #include <QDir>
    QDir d ("..");
    QTreeWidgetItem * branch = new QTreeWidgetItem;
    branch->setText (0, d.absolutePath ());
    ui->treeWidget->addTopLevelItem (branch);
    showBranch (branch, d, 3);

    /*
    QFileInfoList list = d.entryInfoList ();
    foreach (QFileInfo entry, list)
    {
       QTreeWidgetItem * item = new QTreeWidgetItem;
       item->setText (0, entry.fileName());
       if (entry.isDir ())
           item->setForeground (0, QColor ("red"));
       else
           item->setForeground (0, QColor ("green"));
       branch->addChild (item);
    }

    QStringList list = d.entryList ();
    int n = list.count ();
    for (int i = 0; i < n; i ++)
    {
        QString entry = list [i];
        QTreeWidgetItem * item = new QTreeWidgetItem;
        item->setText (0, entry);
        ui->treeWidget->addTopLevelItem (item);
    }
    foreach (QString entry, list)
    {
        QTreeWidgetItem * item = new QTreeWidgetItem;
        item->setText (0, entry);
        ui->treeWidget->addTopLevelItem (item);
    }
    */

    /*
    QTreeWidgetItem * item = new QTreeWidgetItem;
    item->setText (0, "abc");
    item->setForeground (0, QColor ("red"));
    ui->treeWidget->addTopLevelItem (item);

    QTreeWidgetItem * other = new QTreeWidgetItem;
    other->setText (0, "def");
    other->setForeground (0, QColor ("blue"));
    item->addChild (other);

    item->setExpanded (true);
    */
}


